package com.akamai.player
{
	import com.akamai.hd.HDNetStream;
	import com.akamai.hd.HDEvent;
	
	import flash.display.*;
	import flash.events.MouseEvent;
	import flash.geom.*;
	import flash.text.TextField;
	import flash.text.TextFormat;

	public class StatsDisplay extends Sprite
	{
		    	
    	[Embed(source='../../../assets/images/close.png')]
    	private static var closePNG: Class;
    	
    	private var closeButton:Button;
    	private var currentBandwidth:TextField;
    	private var currentBitrate:TextField;
    	private var maxBitrate:TextField;
    	private var ns:HDNetStream;
    	
		public function StatsDisplay()
		{
			super();
			init();
		}
		public function setNetStream(value:HDNetStream):void
		{
			ns = value;
			ns.addEventListener(HDEvent.PROGRESS,onProgress);
		}
		private function onProgress(event:HDEvent):void
		{
			currentBandwidth.text = ns.estimatedMaxbandwidth + " kbps";
			currentBitrate.text = ns.currentIndexBitrate +  " kbps";
			maxBitrate.text = ns.maxIndexAvailableBitrate + " kbps";
		}

		private function init():void
		{
			var fType:String = GradientType.LINEAR;
			var colors:Array = [ 0x12297e, 0x1b2855];
			var alphas:Array = [ 1, 1 ];
			var ratios:Array = [ 0, 255 ];
			var matr:Matrix = new Matrix();
			matr.createGradientBox( width,height,Math.PI/2, 0, 0 );
			var sprMethod:String = SpreadMethod.PAD;
			var sprite:Sprite = new Sprite();
			var g:Graphics = sprite.graphics;
			g.beginGradientFill( fType, colors, alphas, ratios, matr, sprMethod );
			g.drawRoundRect(0, 0,280, 128,16,16);
			g.endFill();
			addChild(sprite);
			//Close button
			closeButton = new Button(30,30,new closePNG());
			closeButton.addEventListener(MouseEvent.CLICK,onClose);
			closeButton.x = 250;
			closeButton.y = 0;
			addChild(closeButton);
			//Timedisplay
			var title:TextField = new TextField();
			title.selectable = false;
			title.width=200;
			title.x =15;
			title.y = 6;
			var tf:TextFormat = new TextFormat("Arial,Helvetica",14,0xFFFFFF,true);
			title.defaultTextFormat = tf;
			title.text = "VIDEO CONNECTION";
			addChild(title);
			var text1:TextField = new TextField();
			text1.selectable = false;
			text1.multiline = true;
			text1.wordWrap = true;
			text1.width=250;
			text1.height=100;
			text1.x =15;
			text1.y = 26;
			var tf2:TextFormat = new TextFormat("Arial,Helvetica",11,0xcccccc,false);
			text1.defaultTextFormat = tf2;
			text1.text = "Quality is automatically selected based on measured conditions.";
			addChild(text1);
			//\n\nCurrent working bandwidth:\nCurrent bitrate playing:\nMax bitrate available:
			var currentBandwidthLabel:TextField = new TextField();
			currentBandwidthLabel.selectable = false;
			currentBandwidthLabel.width=150;
			currentBandwidthLabel.x = 15;
			currentBandwidthLabel.y = 68;
			currentBandwidthLabel.defaultTextFormat = tf2;
			currentBandwidthLabel.text = "Current working bandwidth:";
			addChild(currentBandwidthLabel);
			
			var currentBitrateLabel:TextField = new TextField();
			currentBitrateLabel.selectable = false;
			currentBitrateLabel.width=150;
			currentBitrateLabel.x = 15;
			currentBitrateLabel.y = 82;
			currentBitrateLabel.defaultTextFormat = tf2;
			currentBitrateLabel.text = "Current bitrate playing:";
			addChild(currentBitrateLabel);
			
			var maxBitrateLabel:TextField = new TextField();
			maxBitrateLabel.selectable = false;
			maxBitrateLabel.width=150;
			maxBitrateLabel.x = 15;
			maxBitrateLabel.y = 96;
			maxBitrateLabel.defaultTextFormat = tf2;
			maxBitrateLabel.text = "Max bitrate available:";
			addChild(maxBitrateLabel);
			
			currentBandwidth= new TextField();
			currentBandwidth.selectable = false;
			currentBandwidth.width=100;
			currentBandwidth.x = 155;
			currentBandwidth.y = 68;
			var tf3:TextFormat = new TextFormat("Arial,Helvetica",11,0xFFFFFF,true);
			currentBandwidth.defaultTextFormat = tf3;
			currentBandwidth.text = "";
			addChild(currentBandwidth);
			currentBitrate = new TextField();
			currentBitrate.selectable = false;
			currentBitrate.width=100;
			currentBitrate.x = 128;
			currentBitrate.y = 82;
			currentBitrate.defaultTextFormat = tf3;
			currentBitrate.text = "";
			addChild(currentBitrate);
			maxBitrate = new TextField();
			maxBitrate.selectable = false;
			maxBitrate.width=100;
			maxBitrate.x = 120;
			maxBitrate.y = 96;
			maxBitrate.defaultTextFormat = tf3;
			maxBitrate.text = "";
			addChild(maxBitrate);
		}
		private function onClose(event:MouseEvent):void
		{
			this.visible = false;
		}
		
	}
}