package com.akamai.hdcore.samples.hdn1
{
	import com.akamai.hd.HDMBRObject;
	import com.akamai.hd.HDNetStream;
	import com.akamai.hdcore.samples.utility.HDN1MediaPlayerViewPresenter;
	import com.akamai.hdcore.samples.utility.MediaPlayerView;
	
	import flash.net.NetConnection;
	
	/**
	 * This is a basic presenter class that allows you to override and enhance functionality
	 * within the HDN1MediaPlayerViewPresenter.as class located in the HDCoreSamplesUtility 
	 * project. 
	 * 
	 */	
	public class HDMBRObjectPresenter extends HDN1MediaPlayerViewPresenter 
	{
		
		public function HDMBRObjectPresenter(view:MediaPlayerView, netStream:HDNetStream, netConnection:NetConnection)
		{
			super(view, netStream, netConnection, true/*set to false to hide the buffer metrics*/);
			netStream.loop = false;
		}
		
		/**
		 * Override this method so we can create an HDMBRObject as the resource.
		 **/
		override public function load(resource:String, clipBegin:Number=NaN, clipEnd:Number=NaN):void
		{
			super.load(resource, clipBegin, clipEnd);
			
			var hdMBRObject:HDMBRObject = new HDMBRObject();
			
			hdMBRObject.httpBase = "http://efvod-hdnetwork.akamai.com.edgesuite.net/";
			
			/// These bitrates are in kbps            
			hdMBRObject.addStream("ElephantsDream2_h264_300@14411", 300);
			hdMBRObject.addStream("ElephantsDream2_h264_700@14411", 700);
			hdMBRObject.addStream("ElephantsDream2_h264_1500@14411", 1500);
			hdMBRObject.addStream("ElephantsDream2_h264_2500@14411", 2500);
			hdMBRObject.addStream("ElephantsDream2_h264_3500@14411", 3500);
												
			// For a VOD stream, just add this:
			//hdMBRObject = HDVODFormatter.format(hdMBRObject);

			this.playArgs = [hdMBRObject];			
		}
	}
}
