
package
{
	import com.akamai.hd.HDNetStream;
	import com.akamai.hdcore.samples.hdn1.ManualSwitchingSamplePresenter;
	import com.akamai.hdcore.samples.utility.AkamaiMediaSamples;
	import com.akamai.hdcore.samples.utility.BasePresenter;
	import com.akamai.hdcore.samples.utility.BaseSample;
	import com.akamai.hdcore.samples.utility.ControlBarFactory;
	import com.akamai.hdcore.samples.utility.MediaPlayerView;
	import com.akamai.logger.AkamaiConsoleLogger;
	import com.akamai.logger.AkamaiConsoleLoggerFactory;
	import com.akamai.logger.LoggerEvent;
	
	import flash.display.Sprite;
	import flash.events.ContextMenuEvent;
	import flash.events.Event;
	import flash.net.NetStream;
	import flash.utils.describeType;
	
	import org.osmf.logging.Log;
		
	[SWF(width="640", height="390", frameRate="20", backgroundColor="#1a1a1a")]
	
	/**
	 * This samples plays a multi-bitrate Akamai HDN 1 VOD
	 * stream with the ability to manually switch between
	 * the various quality streams.
	 **/ 
	public class ManualSwitchingSample extends BaseSample
	{
		private static const CAPTION_HEIGHT:Number = 30;
		
		private var logger:AkamaiConsoleLogger;
		private var mediaURL:String = AkamaiMediaSamples.AKAMAI_HDN_MULTI_BITRATE_VOD_1.url; 
						
		public function ManualSwitchingSample()
		{
			addAkamaiConsoleLogger();
		}
		
		override protected function onAddedToStage(event:Event):void
		{
			super.onAddedToStage(event);
			MediaPlayerView(view).video.attachNetStream(netStream);
		}
		
		override protected function getView():Sprite
		{
			return new MediaPlayerView(640, 360, ControlBarFactory.MBR_MANUAL);
		}
		
		override protected function getNetStream():NetStream
		{
			return new HDNetStream(netConnection);
		}
		
		override protected function getPresenter():BasePresenter
		{
			var presenter:BasePresenter = new ManualSwitchingSamplePresenter(MediaPlayerView(view), HDNetStream(netStream), netConnection);
			presenter.load(mediaURL);
			
			return presenter;
		}		
		
		private function addAkamaiConsoleLogger():void
		{
			// Note: the logging framework used here is provisional and the API may change in future releases.
			Log.loggerFactory = new AkamaiConsoleLoggerFactory();
			logger = Log.getLogger(describeType(this).@name) as AkamaiConsoleLogger
			logger.setCallback(onLogEvent);
			AkamaiConsoleLogger.enable();
			
			function onLogEvent(event:LoggerEvent):void
			{
				MediaPlayerView(view).console.log(event.msg);
			}
		}
		
		override protected function onToggleTrace(event:ContextMenuEvent):void
		{
			// Note: the logging framework used here is provisional and the API may change in future releases.
			enableTrace = !enableTrace;
			AkamaiConsoleLogger.enable(enableTrace);
		}				
	}
}
