package
{
	import com.akamai.hd.HDNetStream;
	import com.akamai.hdcore.samples.hdn1.SubClipSamplePresenter;
	import com.akamai.hdcore.samples.utility.AkamaiMediaSamples;
	import com.akamai.hdcore.samples.utility.BasePresenter;
	import com.akamai.hdcore.samples.utility.BaseSample;
	import com.akamai.hdcore.samples.utility.MediaPlayerView;
	import com.akamai.logger.AkamaiConsoleLogger;
	import com.akamai.logger.AkamaiConsoleLoggerFactory;
	import com.akamai.logger.LoggerEvent;
	
	import flash.display.Sprite;
	import flash.events.ContextMenuEvent;
	import flash.events.Event;
	import flash.net.NetStream;
	import flash.utils.describeType;
	
	import org.osmf.logging.Log;
	
	[SWF(width="640", height="390", frameRate="20", backgroundColor="#000000")]
	public class SubClipSample extends BaseSample
	{
		private var mediaURL:String = AkamaiMediaSamples.AKAMAI_HDN_MULTI_BITRATE_VOD_1.url;
		private var logger:AkamaiConsoleLogger;
		
		public function SubClipSample()
		{
			addAkamaiConsoleLogger();
		}
		
		override protected function onAddedToStage(event:Event):void
		{
			super.onAddedToStage(event);
			MediaPlayerView(view).video.attachNetStream(netStream);
		}
		
		override protected function getView():Sprite
		{
			return new MediaPlayerView();
		}
		
		override protected function getNetStream():NetStream
		{
			return new HDNetStream(netConnection);
		}
		
		override protected function getPresenter():BasePresenter
		{
			var presenter:BasePresenter = new SubClipSamplePresenter(MediaPlayerView(view), HDNetStream(netStream), netConnection);
			presenter.load(mediaURL, 30, 70);
			
			return presenter;
		}		
		
		private function addAkamaiConsoleLogger():void
		{
			// Note: the logging framework used here is provisional and the API may change in future releases.
			Log.loggerFactory = new AkamaiConsoleLoggerFactory();
			logger = Log.getLogger(describeType(this).@name) as AkamaiConsoleLogger
			logger.setCallback(onLogEvent);
			AkamaiConsoleLogger.enable();
			
			function onLogEvent(event:LoggerEvent):void
			{
				MediaPlayerView(view).console.log(event.msg);
			}
		}
		
		override protected function onToggleTrace(event:ContextMenuEvent):void
		{
			// Note: the logging framework used here is provisional and the API may change in future releases.
			enableTrace = !enableTrace;
			AkamaiConsoleLogger.enable(enableTrace);
		}		
		
	}
}
